$large
$regfile = "m8def.dat"
$crystal = 8000000
$hwstack = 32
$swstack = 10

Config Lcdpin = Pin , Db4 = Portd.5 , Db5 = Portb.0 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portd.0 , Rs = Portd.1
Config Lcd = 16 * 2

Config Portc.0 = Output                                     'Pin 7 AD9850 W_Clk
Config Portc.1 = Output                                     'Pin 8 AD9850 FQ_UD
Config Portc.2 = Output                                     'Pin 9 AD9850 Data (D7)
Config Portc.3 = Output
Config Portc.4 = Output
Config Portc.5 = Output

Portc.0 = 1                                                 ' outrange
Portc.1 = 1                                                 'maus 2
Portc.2 = 1                                                 'maus 1
Portc.3 = 1                                                 'zu hoch
Portc.4 = 1                                                 'lock
Portc.5 = 1                                                 'zu tief

Const Interval = 1

'Zhlervariable
Dim Counted_value As Long                                   'LONG: bis 2147483647
Dim Counted_value_saved As Long
Dim Delta As Long
Dim Oben As Word
Dim Unten As Word
'Dim Regelspeed As Word
'Dim Waitatlock As Word

Oben = 87                                                   'obere regelfrequenz
Unten = 87                                                  'untere regelfrequenz
'Regelspeed = 20                                             ' regelgeschwindigkeit
'Waitatlock = 250                                            ' bei lock warten bis weiter

'Timer0/Counter0 einstellen und berlauf-Interrupt aktivieren
Config Timer0 = Counter , Edge = Falling
On Timer0 On_timer0

Load Timer0 , Interval

Enable Timer0
Enable Interrupts


Do
   'Mit ``DISABLE INTERRUTPS`` wird sichergestellt, dass kein Interrupt-Handler
   'den Wert der Variable COUNTED_VALUE verndert, whrend damit gerechnet wird.
   Disable Interrupts

   'herausfinden, wieviele Zhlereignisse seit der letzten Berechnung auftraten
   'und den neuen Zhlstand sichern
   Delta = Counted_value - Counted_value_saved
   Counted_value_saved = Counted_value

   'Der Befehl ``ENABLE INTERRUPTS`` gibt die Interruptroutinen wieder frei.
   'Sollte in der Zwischenzeit ein Interrupt ausgelst worden sein, wird dieser
   'Interrupt jetzt nachgeholt.
   Enable Interrupts

   'Portc.5 = 1
   'Portc.4 = 1
   'Cls
   'Lcd Delta

   If Delta < 7 Then
   Portc.0 = 0
   Portc.5 = 1
   Portc.4 = 1
   Portc.3 = 1
   Goto Warte
   End If

   If Delta > 200 Then
   Portc.0 = 0

   Portc.5 = 1
   Portc.4 = 1
   Portc.3 = 1
   Goto Warte
   End If

   Portc.0 = 1




   If Delta > Oben Then

   Portc.1 = 1
   Waitms 40
   Portc.2 = 1
   Waitms 40
   Portc.2 = 0
   Portc.1 = 0

   Portc.5 = 1                                              ' zu niedrig aus
   Portc.4 = 1                                              ' lock aus
   Portc.3 = 0                                              ' zu hoch an
   Goto Warte:
   End If


   If Delta < Unten Then
   Portc.2 = 1
   Waitms 40
   Portc.1 = 1
   Waitms 40
   Portc.2 = 0
   Portc.1 = 0

   Portc.3 = 1                                              ' zu hoch aus
   Portc.4 = 1                                              'lock aus
   Portc.5 = 0                                              ' zu tief an
   Goto Warte:
   End If

   'If Delta < Oben Then
   'Waitms 10
   'Portc.5 = 1
   'Goto Warte:
   'End If

   'If Delta > Unten Then
   'Waitms 10
   'Portc.4 = 1
   'Goto Warte:
   'End If

   'Portc.4 = 0
   'Portc.5 = 1
   Portc.4 = 0
   Portc.5 = 1
   Portc.3 = 1
   Waitms 80

   Warte:
   'If Delta > Unten And Delta < Oben Then

   'Waitms Waitatlock
   Waitms 5
   'End If

   'If Delta < Unten And Delta > Oben Then Portc.4 = 1
   'Waitms Regelspeed
Loop

End


On_timer0:
   'Mit dem Befehl LOAD wird der Wert des Timer0 gesetzt, damit der Timer
   'nach <Interval> Zhlereignissen wieder berluft.
   Load Timer0 , Interval

   'Zhlervariable um <Interval> erhhen
   Counted_value = Counted_value + Interval
Return